<template>
  <div class="SetupPageRds">
    <b-form-input
      :disabled="sliderValue <= 0 || isNaN(sliderValue)"
      v-on:input="update($event)"
      type="range"
      :min="min"
      :max="max"
      :value="sliderValue"
    />
    <div>
      {{ sliderValueText }}
      <b-link :href="quotaLink" v-if="isProjectOwner">{{
        $t("needMore")
      }}</b-link>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { ProjectApi } from "@coscine/api-connection";
import { GuidUtil, LinkUtil } from "@coscine/app-util";
import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

export default Vue.extend({
  name: "SetupPageRds",
  components: {},
  data() {
    return {
      min: 1,
      max: 25,
      quotaLink: LinkUtil.getProjectLink("QuotaManagement"),
      sliderValue: 0,
      sliderValueText: "0",
    };
  },
  methods: {
    update(event: any) {
      const pos = parseInt(event, 10);
      this.sliderValue = pos;
      this.group(pos);
      this.$set(this.resource.resourceTypeOption, "Size", pos);
      this.$emit("sliderValChange", this.sliderValue);
    },
    group(num: any) {
      const groupingPoints = [-9, -6, -3];
      const grouped = num.toString().split("");
      groupingPoints.map((point) => {
        grouped.splice(point, 0, " ");
      });
      this.sliderValueText =
        "" +
        grouped.join("").trim() +
        this.$t("BucketSizeNoteMiddle") +
        num * 2048 +
        this.$t("BucketSizeNoteEnd");
      return this.sliderValueText;
    },
    retrieveQuota() {
      ProjectApi.getQuotas(this.projectId, (response: any) => {
        for (const element of response.data) {
          if (element.id === this.resource.type.id) {
            this.max = element.allocated - element.used;
            if (this.max <= 0) {
              this.max = 0;
            }
            if (this.sliderValue > this.max) {
              this.sliderValue = this.max;
            } else if (this.max > 0 && this.sliderValue === 0) {
              this.sliderValue = 1;
            }
            this.group(this.sliderValue);
            this.$set(
              this.resource.resourceTypeOption,
              "Size",
              this.sliderValue
            );
            this.$emit("sliderValChange", this.sliderValue);
          }
        }
      });
    },
    validateResource() {
      return this.sliderValue >= 0 && !isNaN(this.sliderValue);
    },
  },
  props: {
    resource: Object,
    isProjectOwner: Boolean,
    projectId: String,
  },
  watch: {
    "resource.resourceTypeOption"() {
      this.retrieveQuota();
    },
  },
  created() {
    if (this.resource.resourceTypeOption.Size !== undefined) {
      this.group(this.resource.resourceTypeOption.Size);
    } else {
      this.group(this.sliderValue);
      this.$set(this.resource.resourceTypeOption, "Size", this.sliderValue);
      this.$emit("sliderValChange", this.sliderValue);
    }
    this.retrieveQuota();
  },
});
</script>
